module bob
open bytes
open crypto_interface
open assumptions

(* -------------- Bob Interface -------------- *)
val Bob: eq bytes -> cb:cipher{| (FromBboth (L cb) (R cb)) 
								&& ( exists (mLb:bytes) (mRb:bytes).( 
											(Encryptedboth mLb mRb (L cb) (R cb)) 
											&& (Marshboth (L v2) (R v1) mLb mRb) ) 
								) |}	

(* -------------- Bob Implementation -------------- *)
								
let Bob arg = 
	let v1Byt = I2B v1 in
	let v2Byt = I2B v2 in
	let vb = choice v2Byt v1Byt in
	let cb = encB_in_progress vb in
	cb
	
(* -------------- Trash -------------- *)
(* 
val Bob: eq bytes -> cb:cipher{| (FromBboth (L cb) (R cb)) 
								&& ( exists (mLb:int) (mRb:int).( (Encryptedboth mLb mRb (L cb) (R cb)) 
																&& (mLb = L v2) && (mRb = R v1) ) 
								) |}
COMMENT: See Alice.fst. *)