module alice_interface
open bytes
open crypto_interface
open assumptions

(* -------------- Alice Interface -------------- *)
val Alice: eq bytes -> ca:cipher{| (FromAboth (L ca) (R ca)) 
								&& ( exists (mLa:bytes) (mRa:bytes).( 
											(Encryptedboth mLa mRa (L ca) (R ca)) 
											&& (Marshboth (L v1) (R v2) mLa mRa) ) 
								) |}	
								
(* -------------- Trash -------------- *)
(* COMMENT: Does not work for unknown reasons. Should work normally.
val Alice: eq bytes -> ca:cipher{| (FromAboth (L ca) (R ca)) 
								&& ( exists (mLa:bytes) (mRa:bytes) (zLa:int) (zRa:int).( 
											(zLa = L v1) && (zRa = R v2) &&
											(Encryptedboth mLa mRa (L ca) (R ca)) 
											&& (Marshboth zLa zRa mLa mRa) ) 
								) |}
*)