module bob_interface
open bytes
open crypto_interface
open assumptions

(* -------------- Bob Interface -------------- *)
val Bob: eq bytes -> cb:cipher{| (FromBboth (L cb) (R cb)) 
								&& ( exists (mLb:bytes) (mRb:bytes).( 
											(Encryptedboth mLb mRb (L cb) (R cb)) 
											&& (Marshboth (L v2) (R v1) mLb mRb) ) 
								) |}			

								
(* -------------- Trash -------------- *)
(* COMMENT: previous interface without marshalling.
val Bob: eq bytes -> cb:cipher{| (FromBboth (L cb) (R cb)) 
								&& ( exists (mLb:int) (mRb:int).( (Encryptedboth mLb mRb (L cb) (R cb)) 
																&& (mLb = L v2) && (mRb = R v1) ) 
								) |}
*)